      subroutine agsx(B1,B2,noofbv,noofxbv,m,agesex,nooft,noofv)

!*    17 Tables
!     Many LBS/SAS tables require the derivation of age variables
!     with categories containing 'pensionable age'.  Such gender
!     differentiated age categories are not contained in the pre-
!     processed SAR dataset.
!
!     In finditjm, the relevant gender differentiated age variable is 
!     initially treated as an age variable with male pensionable age 
!     age categories (i.e. 45-pa,pa+ => 45-64,65+).  On this basis,
!     B1(32) (base variable age) is assigned a provisional value indexing
!     it to the SAS age variable being considered. Hence, for variable
!     16-29,30-44,45-pa,pa+, the base variable age of 63 is intially
!     given an index value of 3.
!
!     For appropriate tables, this sub-routine checks to see if an
!     individual if female and aged 60 to 64.  If they are, then the
!     wrong index value has been assigned.  This may be corrected simply
!     by adding 1 to the index value assigned.  Hence a female aged 63
!     in the example above is reassingned a value of 4 (3+1).  If the
!     female is 65 or over, the correct value has already been assigned.
!
!     NOTE:  at present there is no 'memory' element to this
!            sub-routine; each time a household/table combination is
!            picked, the new 'base' variable must be derived

      integer B1(1:noofxbv), B2(1:noofv), AgeSex(1:nooft)
      integer noofbv, noofxbv, m, nooft, noofv

!     if table contains gender differentiated age variable

      goto (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17) m                                                !*

 1    return
 2    return
 3    return
 4    return
 6    return
 8    return
!*
 9    return
 10   return
 11   return
 12   return
 14   return
 15   return 
 16   return
 17   return

 5    continue
 7    continue
 13   continue
 
!     if individual is female, then

      if (B1(55) .eq. 2) then

!     if individual is aged 60-64, age variable index=index+1

      if ((B1(32) .gt. 59) .and. (B1(32) .lt. 65)) B2(agesex(m))= &
      B2(agesex(m))+1

      endif

      return
      end
