      subroutine derivebvh(B1,noofbv,noofxbv,m)

!*    17 Tables, for household variables
!     Many LBS/SAS tables require the derivation of variables (such as
!     household composition) which are not contained in the pre-
!     processed SAR dataset.  This subroutine sets out to derive such
!     derived variables, as and when the need arises.
!     NOTE:  at present there is no 'memory' element to this
!            sub-routine; each time a household/table combination is
!            picked, the new 'base' variable must be derived

      integer B1(1:noofxbv)
      integer noofbv, noofxbv, m, male, female, ind, k1
      integer Dep,Ndep,EconAct

 4000 format (i1,i6,6i2,2i1,i2,4i1,i2,i3,2i1,i2,i3,2i1,2i2,3i1,i2, &
              i1,2i2,6i1)

      goto (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17) m                                                !*

 1    return
 2    goto 1000         ! HHComp01 B1(66)
 3    return
 4    return
 5    return
 6    goto 2000         ! HHComp02 B1(67)
 7    return
 8    goto 3000         ! SEGHOH01 B1(68)
!*
 9    return
 10   return           
 11   return            
 12   goto 6000         ! EthGHOH02 B1(70)
 13   return
 14   return
 15   goto 1000         !HHComp03 need B1(66)
 16   return
 17   return

!     Table S42 - household

 1000    B1(66)=0

!     1.  Find number of resident adults of each sex

      male=0
      female=0

      do 1020,ind=1,B1(13)
         read(2,4000,rec=(B1(28)+(ind-1))) (B1(k1), k1=29,noofbv)
!         write(8,4000) (B1(k1), k1=29,noofbv)
         if (B1(54) .ne. 3) then
            if ((B1(64) .ne. 1) .and. (B1(64) .ne. 2)) then
               if (B1(55) .eq. 1) then
                  male=male+1
               else
                  female=female+1
               endif
            endif
         endif
 1020    continue

!     2.  Find household composition type

      if ((male+female) .eq. 1) then
         if (B1(19) .eq. 0) then
            if (B1(25) .eq. 1) B1(66)=1
            if (B1(25) .eq. 0) B1(66)=2
         else
            if (B1(19) .ge. 1) B1(66)=3
         endif
      endif
      if ((male .eq. 1) .and. (female .eq. 1)) then
         if (B1(19) .eq. 0) B1(66)=4
         if (B1(19) .ge. 1) B1(66)=5
      endif
      if (((male+female) .eq. 2) .and. ((male .eq. 2) .or. &
          (female .eq. 2))) then
         if (B1(19) .eq. 0) B1(66)=6
         if (B1(19) .ge. 1) B1(66)=7
      endif
      if (((male+female) .ge. 3) .and. (male .ge. 1) .and. &
          (female .ge. 1)) then
         if (B1(19) .eq. 0) B1(66)=8
         if (B1(19) .ge. 1) B1(66)=9
      endif
      if (((male+female) .ge. 3) .and. ((male .eq. 0) .or. &
          (female .eq. 0))) then

                 if (B1(19) .eq. 0) B1(66)=10
         if (B1(19) .ge. 1) B1(66)=11
      endif

      return

!     Table 29 - household

 2000 B1(67)=0

!     Number of dependants by number of non-dependants resident in
!     household

      Dep=0
      NDep=0

!     1.  Find no. of resident dependants and non-dependants in h/hold

!     Read in household, one individual at a time

      do 2020,ind=1,B1(13)
         read(2,4000,rec=(B1(28)+(ind-1))) (B1(k1), k1=29,noofbv)
!         write(8,4000) (B1(k1), k1=29,noofbv)
         

!     if Resident
         if (B1(54) .ne. 3) then
            
            if (B1(63) .eq. 0) NDep=NDep+1
            if (B1(63) .eq. 1) Dep=Dep+1

         endif

 2020 continue

!     2.  Classify households

      if ((NDep .ge. 1) .and. (Dep .eq. 0)) B1(67)=1

      if (NDep .eq. 0) then
         if (Dep .eq. 1) B1(67)=2
         if (Dep .eq. 2) B1(67)=3
         if (Dep .ge. 3) B1(67)=4
      endif

      if (Dep .ge. 1) then
         if (NDep .eq. 1) B1(67)=5
         if (NDep .eq. 2) B1(67)=6
         if (NDep .ge. 3) B1(67)=7
      endif

      if ((Dep .eq. 0) .and. (NDep .eq. 0)) B1(67)=0

      return

!     Table S86 - Household

!     HOH by SEG and EconPrim
!     Note - according to Definitions (OPCS 1991), only EconPrim is
!     used for County Report tabulations, except when identifying
!     economically active students.

 3000 B1(68)=0

!     Go through household until head of household is identified

      do 3020,ind=1,B1(13)
         read(2,4000,rec=(B1(28)+(ind-1))) (B1(k1), k1=29,noofbv)
!         write(8,4000) (B1(k1), k1=29,noofbv)
         
!     if head of household

         if (B1(53) .eq. 0) then

            EconAct=0

!     if resident

            if (B1(54) .lt. 3) then

!***  if economically inactive 
                       
            if (B1(36) .gt. 6) B1(68)=19       ! including all students at moment 
                        
!     if economically active

            if ((B1(36) .gt. 0) .and. B1(36) .lt. 7) EconAct=1


!     Detect economically active student HOHs
            if (B1(36) .eq. 7) then
               if ((B1(37) .gt. 0) .and. (B1(37) .lt. 5)) EconAct=1
            endif

            if (EconAct .eq. 1) then
               if (B1(57) .eq. 0) B1(68)=0
               if (B1(57) .eq. 1) B1(68)=1
               if (B1(57) .eq. 3) B1(68)=2
               if (B1(57) .eq. 4) B1(68)=2
               if (B1(57) .gt. 4) B1(68)=B1(57)-2
            endif


!*            if (B1(36) .gt. 7) B1(68)=19


            if (B1(36) .eq. 0) B1(68)=0

!*        write(8,*)B1(3),B1(57),B1(68),B1(32),B1(55),B1(36)


         endif
!     if Resident

!     if not resident
         if (B1(54) .eq. 3) B1(68)=0

         endif
!     if HOH

 3020    continue
    
      return

!     Table S49, S43 - EthGroup02 of HOH

 6000 B1(70)=0

!     Go through household until head of household is identified

      do 6020,ind=1,B1(13)
         read(2,4000,rec=(B1(28)+(ind-1))) (B1(k1), k1=29,noofbv)
         
!     if head of household and resident

         if (B1(53) .eq. 0 .and. B1(54) .lt. 3)  then

                if (B1(39) .eq.1 ) B1(70)=1 
                if (B1(39)>1 .and. B1(39)<=4) B1(70)=2 
                if (B1(39)>4 .and. B1(39)<=7) B1(70)=3 
                if (B1(39)>7 ) B1(70)=4
         endif

 6020    continue
    
      return
      end
