      subroutine FindHTjm(T,metaV,V,fname,nooff,noofbv,noofxbv,noofv, &
      nooft,m,C,D,B1,B2,noofh,maxj,MaxH,j,minC,maxC)

!     Find the LBS/SAS look-a-like table vector, Tjm, aggregating
!     household data

      integer nooff,noofbv,noofxbv,noofv,nooft,m,noofh,maxj,maxh
      integer T(0:maxj,1:Nooft)
      integer metaV(1:noofv), V(1:noofv,minC:maxC), D(0:noofv,1:nooft)
      integer C(1:noofv)
      integer B1(1:noofxbv), B2(1:noofv)
      integer j,k,s,tail,valid,minC,maxC
      character*50 fname(1:nooff)

!     Derive base variables required for table, but not present
!     in derived SAR dataset (household)

      call derivebvh(B1,noofbv,noofxbv,m)

!      write(8,3000) (B1(s),s=1,28)
!      write(8,*) B1(66)
! 3000 format (I1,I6,I2,5I1,I2,I1,3I2,i1,3i2,i1,2i2,i1,2i2,i1,3i2,i6)

!     Convert attribute values as recorded in sample population
!     (eg Age=99) into attribute value relevant for current table
!     (eg Age10=4).  This generates a second, table specifi! buffer,B2(k)

      do 2, k=1,noofv

!         write(8,*) d(k,m), B1(metaV(k)), V(k,B1(metaV(k))), metaV(k)

         if (d(k,m) .eq. 1) then
            B2(k)=V(k,B1(metaV(k)))
         else 
            B2(k)=-1   
         end if 
                                
 2    continue

!      write(8,'(8i6)') (B1(metaV(k)), k=1,noofv)
!      write(8,'(8I6)') (B2(k), k=1,noofv)

!     Test to see if household is 'eligible' ('valid') for table

      valid=1

!     First, use table specifi! filter

      call filter(B1,noofxbv,valid,m)

!      if (valid .eq. 0) write(8,'("HH  ",I8,I6," is now invalid")'),
!     *   B1(2), B1(31)

!     Then check for a valid value of variable k, if k is present in
!     table **(this check could be made table specifi! if desired)**

      do 7, k=1,noofv
         if ((d(k,m) .eq. 1) .and. (B2(k) .lt. 0)) then
            valid=0
!            write(8,*) 'Ind. invalidated by second screen'
         endif
 7    continue

!     Find table vector element j for a current household's
!     attribute combination (if 'valid' for table)

      j=0

      if (valid .eq. 1) then

         do 3,k=1,noofv-1
            if (B2(k) .gt. 1) then
               tail=1
               do 4, s=k+1,noofv
                  tail=tail*(C(s)**d(s,m))
 4             continue
            endif
            if (B2(k) .gt. 1) then
               j=j+(B2(k)-1)*tail
            endif
 3       continue
         if (B2(Noofv) .gt. 0) then 
            j=j+B2(noofv)
         else
            j=j+1
         endif

      endif
!     if valid for table

!      WRITE(8,*) j

      return
      end
