      subroutine FindITjm(T,metaV,V,fname,nooff,noofbv,noofxbv,noofv, &
      nooft,m,C,D,B1,B2,noofh,maxj,j,ind,minC,maxC,agesex)

!     Finds the LBS/SAS table look-a-alike vector Tjm for tables
!     containing individual counts

      integer nooff,noofbv,noofv,nooft,m,noofh,maxj
      integer T(0:maxj,1:Nooft)
      integer metaV(1:noofv), V(1:noofv,minC:maxC), D(0:noofv,1:nooft)
      integer C(1:noofv)
      integer B1(1:noofxbv), B2(1:noofv), agesex(1:nooft)
      integer ind,k,k1,s,tail,valid,j,minC,maxC,noofxbv
      character*50 fname(1:nooff)

      j=0

!     read in individual record

      read(2,4000,rec=ind) (B1(k1), k1=29,noofbv)

 4000 format (i1,i6,6i2,2i1,i2,4i1,i2,i3,2i1,i2,i3,2i1,2i2,3i1,i2, &
              i1,2i2,6i1)

!     Derive base variables required for table, but not present
!     in derived SAR dataset (individual)

      call derivebvi(B1,noofbv,noofxbv,m) 
  
    
!      write(8,4000) (B1(k1), k1=29,noofbv) 
      
!     Convert attribute values as recorded in sample population
!     (eg Age=99) into attribute value relevant for current table
!     (eg Age10=4).  This generates a second, table specifi! buffer,B2(k)
      do 2, k=1,noofv

!         write(5,*)' k,m,metaV(k),B1(metaV(k)=',k,m,metaV(k),B1(metaV(k)) 
!         write(5,*) d(k,m), B1(metaV(k)), V(k,B1(metaV(k)))

         if (d(k,m) .eq. 1) then
            B2(k)=V(k,B1(metaV(k)))
         else 
            B2(k)=-1   
         end if 
         
!         write(9,*)' m,k,metaV(k),B1(metaV(k)),d(k,m),B2(k)='
!         write(9,*)m,k,metaV(k),B1(metaV(k)),d(k,m),B2(k)          
 2    continue      
 
      call agsx(B1,B2,noofbv,noofxbv,m,agesex,nooft,noofv)

!      write(9,'(8i6)') (B1(metaV(k)), k=1,noofv)
!      write(9,'(8I6)') (B2(k), k=1,noofv)
!      write(9,*) 'From B1, age=',B1(32),'  sex=',B1(55),
!     *'  mstat=',B1(47)
!      write(9,*) 'From B2, age=',B2(1),'  sex=',B2(3),
!     *'  mstat=',B2(2)

!     Test to see if individual is 'eligible' ('valid') for table

      valid=1

!     First, use table specifi! filter

      call filter(B1,noofxbv,valid,m)

!     Then check for a valid value of variable k, if k is present in
!     table **(this check could be made table specifi! if desired)**

      do 7, k=1,noofv
         if ((d(k,m) .eq. 1) .and. (B2(k) .lt. 0)) then
            valid=0
!            write(8,*) 'Ind. invalidated by second screen'
         endif
 7    continue

!     Find table vector element j for a current individual's 
!     attribute combination (if 'valid' for table)

      if (valid .eq. 1) then

         do 3,k=1,noofv-1
            if (B2(k) .gt. 1) then
               tail=1
               do 4, s=k+1,noofv
                  tail=tail*(C(s)**d(s,m))
 4             continue
            endif
            if (B2(k) .gt. 1) then
               j=j+(B2(k)-1)*tail
            endif
 3       continue
         if (B2(Noofv) .gt. 0) then 
            j=j+B2(noofv)
         else
            j=j+1
         endif

      endif
!     if valid for table

!      if (j .eq. 0) write(9,*) 'j=0 for ind ',B1(28)+(ind-1)

      return
      end
