      Program moretab_45

!     This program tabulates data (L45 formate) from all of the SAR 
!     households identified as being in the area of interest.
!       for Nk=100 runs


!     FName(I) links channel I in read and write statements to a file
!     with the name FName(i), as read in by the sub-routine FNames
    
      integer H13(29:215789), H28(29:215789)

!     H13() records the value of PersInHH for every household
!     H28() records the value of FirstInd for every household

      integer Comb(1:350)

!     Comb records the combination of households currently being
!     evaluated

      integer nooff,NoofH,SarSize,noofi,ind,Nk,run,i
      integer A45(2,4,3,4)
      integer ig,ia,iep,it, total
      character*6 edcode       

      SARSIZE=215789
      NOOFI=541894
      Nk=100                    !*********************************************

!     NoOfF = no. of files in tabulate.filelist
!     NoOfH = number of households in spatial unit (ED)
!     NoOfT = no. of tables used to constrain SAR
!     NoOfI= no. of individuals in sample population file
!     MaxJ = largest possible value of Nm
!     SarSize=number of households in SAR
!     NoOfI = number of individuals in SAR

      open(9,file='E:/Pop91t17/Data/HJ.sar',status='old')
      
      open(10,file='E:/Pop91t17/Data/hh.sar',access='direct', &
           status='old',form='formatted',recl=62)
      open(11,file='E:/Pop91t17/Data/hhind.sar',access='direct', &
           status='old',form='formatted',recl=72)
      
!     Read in the values of PersInHH (H13) and FirstInd (H28) for
!     every household


      call readpop2(H13,H28,SarSize)

!     Open file containing list of EDs to be processed by tabulate
!     Last action to be performed before ED loop entered

      open(6,file='E:/Pop91t17/dagf/edlist.dagf')
      
   2    close(5)       
        close(7)

         read(6,'(a6)',end=2000) edcode 
!**********           
!        open(5,file='E:/Pop91t17/leeds2/res/'//edcode//'.res')             ! input   
        open(5,file='E:/Pop91t17/dagf/res/'//edcode//'.res')             ! input 
        open(7,file='E:/Pop91t17/dagf/estimates/'//edcode//'.e45')       ! output

        
        read(5,*) noofh
        
        do k=1,Nk  
       
!*******                
                read (5,*) run
         write(*,*) edcode,k 
                read(5,*) (Comb(i), i=1,noofh)                
             
                call Atab45(noofh,h13,h28,SarSize,comb,A45)
                
                write(7,*) k
                do it=1,4; do iep=1,3
                write(7,'(8i6)') ((A45(ig,ia,iep,it),ig=1,2),ia=1,4)
                enddo; enddo         
!*******************************                                                                                                          
                total=0
                do it=1,4; do iep=1,3; do ia=1,4; do ig=1,2
                total=total+A45(ig,ia,iep,it)
                enddo;enddo;enddo;enddo
                
                if(noofh /= total) write(*,*) noofh,total,noofh-total
!**************                        
        enddo 
        
         
          
            
        goto 2 
        
  2000 continue        
      
  
      stop
      end program moretab_45
      
!-----------------------------------------------------------------------------------      
      subroutine readpop2(H13,H28,SarSize)

!     This subroutine reads PersInHH and FirstInd into arrays H13
!     and H28 respectively, for every household in SAR.

      integer SarSize
      integer H13(29:SarSize),H28(29:SarSize)
      integer hhno
      
      do hhno=29,Sarsize

         read(9,*) H13(hhno), H28(hhno)

      enddo
       
      return
      end
      
!--------------------------------------------------------------------------
      subroutine Atab45(noofh,h13,h28,SarSize,comb,A45)

!     This subroutine produce a L45-like array A45 for a given comb 
!       household head: sex(2) by age(4) by econprim(3) by tenure(4)
      
      integer hhno,noofh,ind,hh,SarSize
      integer comb(1:noofh),h13(29:SarSize),h28(29:SarSize),b1(65)
      integer A45(2,4,3,4), ig,ia,iep,it,SEG,EconAct

      A45=0
      
!     1.  For each household in combination

      do 5,hh=1,noofh

         hhno=comb(hh)
      
         read(10,3000,rec=hhno) (B1(k),k=1,28)

 3000    format (i1,i6,i2,5i1,i2,i1,3i2,i1,3i2,i1,2i2,i1,2i2,i1,3i2,i6)
       
!     skip if household has no residents
       if (B1(26) .eq. 0) goto 5

!        Find first ind in household

      do 10,ind=h28(hhno),(h28(hhno)+h13(hhno)-1)


!     For each individual in household

      read(11,4000,rec=ind) (B1(k1), k1=29,65)

4000  format (i1,i6,6i2,2i1,i2,4i1,i2,i3,2i1,i2,i3,2i1,2i2,3i1,i2, &
                i1,2i2,6i1)

!     if head of household

         if (B1(53) .eq. 0) then

            EconAct=0

!     if resident

            if (B1(54) .lt. 3) then

!***  if economically inactive 
                       
            if (B1(36) .gt. 6) SEG=19       ! including all students at moment 
                        
!     if economically active

            if ((B1(36) .gt. 0) .and. B1(36) .lt. 7) EconAct=1

!     Detect economically active student HOHs
            if (B1(36) .eq. 7) then
               if ((B1(37) .gt. 0) .and. (B1(37) .lt. 5)) EconAct=1
            endif

            if (EconAct .eq. 1) then
               if (B1(57) .eq. 0) SEG=0
               if (B1(57) .eq. 1) SEG=1
               if (B1(57) .eq. 3) SEG=2
               if (B1(57) .eq. 4) SEG=2
               if (B1(57) .gt. 4) SEG=B1(57)-2
            endif
!*           
            if (B1(36) .eq. 0) SEG=0

         endif

!* iep
        if (SEG == 19) then
                                        iep=3   !econ. inactive
        elseif (B1(36) == 6) then
                                        iep=2   !unemployed
        else
                                        iep=1   !econ. active 
                                                !(excluding unemployed)
        endif

!* it   
        it=0
        if (B1(12) >= 7)                  it=4
        if (B1(12) == 6)                  it=3              
        if ((B1(12)< 6).and.(B1(12)>2))   it=2
        if (B1(12) < 3)                   it=1                                
        
        if(it == 0) then 
        write(*,*) 'it=0', B1(12); stop
        endif
!* ig   
        ig=B1(55)

!* ia
        if(B1(32) <=29 ) then
                                        ia=1            !16-29
        elseif((B1(32)> 29) .and. (B1(32) <=44)) then
                                        ia=2            !30-44
        elseif(ig == 1) then
                if((B1(32)> 44) .and. (B1(32) <=65)) then
                                        ia=3            !45-65 male
                else
                                        ia=4
                endif
        elseif(ig == 2) then
                if((B1(32)> 44) .and. (B1(32) <=60)) then
                                        ia=3            !45-60 female
                else
                                        ia=4
                endif                
        endif        

        A45(ig,ia,iep,it)=A45(ig,ia,iep,it)+1
                                                                

        endif   ! end if HOH


!     Next individual
 10   continue
 5    continue


      return
      end
