      PROGRAM Pop91_17

!     Date: 19/7/2001     use for comparison with SR

!     This is the main part of the program pop91_17.for; an attempt to
!     iteratively fit SAR data to SAS data.
 
!     parameter declarations follow
      
      character*50 FName(1:17)   
       
!     FName(I) links channel I in read and write statements to a file
!     with the name FName(i), as read in by the sub-routine FNames
      
!*    Array need adjusted: Nm,U,T,R,H,I,maxRjm,minRjm, STAE, and nooft

      integer Nm(1:17), cell                                                          !*

!     No. of cells in table vectors (i.e. Ujm, Tjm and Rjm), for
!     each table m (maximum no. of cell is 198 in table 8)

      integer U(0:198,1:17)                                                      !*
      integer T(0:198,1:17)                                                      !*
      integer R(0:198,1:17)                                                      !*
      
!*    new added array E (estimated) to store Tjm over maximum 100 replications
!*    as the input of subroutine analysis
         
        integer E(1:198,1:17,1:100)
!        integer E(1:198,1:17,1)                                                        !*
          
!     U(j,m) is the table vector containing SASPAC91 data in cells
!     1,..,j,..Nm for each SAS/LBS table, m.  U(0,m) = table total.
!     T(j,m) is the equivalent table vector, found by 'tabulation'
!     of SAR household data
!     R(j,m) is the remainder vector found by subtraction of T from U.

      integer H(29:215789,1:17), I(1:541894,1:17)                                 !*

!     H records the value of j assigned to each household for a table
!     Note - first 28 household records unavailable (PersInHH>11)
!     I records the value of j assigned to each individual for a table
!     N.B.  This is known to be an inefficient way of storing info.

      integer H13(29:215789), H28(29:215789)

!     H13() records the value of PersInHH for every household
!     H28() records the value of FirstInd for every household

      integer Comb(1:665), CombK(1:665,1:100)           

!     Comb records the combination of households currently being
!     evaluated (maximum no. of househole for a ED in E&W is 665)
!*    CombK store max=100 runs results  

      integer maxRjm(1:17), minRjm(1:17)                                           !*

!     The j values for Rjm associated with min. and max. Rjm scores

      integer lnblnk,getpid
!     typing of function lnblnk(), getpid()

      real F(1:198,1:17)
!     the constant part of RSumZm2        

      integer Nooft,nooff,NoOfH,MaxJ,SarSize,it,noofi,TAE,STAE(17)               !* 
      integer ij,im,iseed(100),k,maxseed,i,Bestk,m                                            !***
      character*6 edcode
      real :: time1, time2
      character*4 wdcode, wdcode1
      integer wardT86(1:76)
      integer Index1(10),Index2(10),Index3(10)
      integer BestIndex1,BestIndex2,BestIndex3  
      character*4 table(17)
!**      
        integer AreaCode, AreaSarSize, AreaSarComb(42000) 
               ! the largest area sar size is about 41,000 (Rest of S. East)                 
                                              
!*      tables can be switched on/off by setting the values of 1 or 0
        
        integer switch(1:17), maxevals        
!*--------------------------------------------------------------------
!**     
        AreaSarComb=0
        AreaCode=2      ! Yorkshire$Hamberside   
      NOOFT=17                                                                   !*
      NOOFF=17
      MAXJ=198
      SARSIZE=215789
      NOOFI=541894
      maxseed=100                 
      !*****************************************************

!     NoOfF = no. of files in Pop91.filelist
!     NoOfH = number of households in spatial unit (ED)
!     NoOfT = no. of tables used to constrain SAR
!     NoOfI= no. of individuals in sample population file
!     MaxJ = largest possible value of Nm
!     SarSize=number of households in SAR
!     NoOfI = number of individuals in SAR
!     TAE = Total Absolute Error
   
!     Read in filenames for linkage to read/write statements

      call fnames(fname,nooff)

!     open channel 1 for input from HJ.sar - values of j for hholds
!     open channel 2 for input from hhind.sar - values of j for Inds

!     open(1,file=fname(1)(1:lnblnk(fname(1))),status='old')
!     open(2,file=fname(2)(1:lnblnk(fname(2))),status='old')

        write(5,*) ' start Pop91_17' 

!**   find area sar comb

      call AreaSar(SarSize,AreaCode,AreaSarSize,AreaSarComb)        
        
!*
      open(15,file=fname(15),status='old')
 
        read (15,*) (switch(k),k=1,nooft)

      do k=1,nooft
        write (5,*) 'table  =',k,'   swtich  =', switch(k)
      enddo  

      open(1,file=fname(1),status='old')
      open(2,file=fname(2),status='old')

!     Read in the values of PersInHH (H13) and FirstInd (H28) for
!     every household 

      call readpop(H,I,H13,H28,SarSize,noofi,nooft)                             !*

!     Read in size of table vectors (U/T/Rjm) for each table, m

      call ReadNm(Nm,nooft,fname,nooff,table)
 
!     Open file containing list of EDs to be processed by pop91
!     Last action to be performed before ED loop entered

      open(16,file=fname(16),status='old')

      read(16,*) iseed(1:100)                  ! initial seed position

!*        
        call cpu_time(time1) 
           
!     Open(12,file=fname(12)(1:lnblnk(fname(12))),status='old')

!      Open(11,file=fname(11),status='old')          ! WDlist
      Open(12,file=fname(12),status='old')          ! EDlist

                
!  3     read(11,'(a4)') wdcode
         wdcode='abcd'
        
!     Read in name of next ED to be processed and open relevant
!     data file, having first closed previous ED data file

        open(14,file=fname(14),status='replace')
        open(13,file=fname(13),status='replace') 
    

  2    close(7)

      read(12,'(a6)',end=1999) edcode

      open(7,file='E:/Pop91t17/Data/Sas/'//edcode//'.dat')

      wdcode1(1:4)=edcode(1:4) 
                  
      if(wdcode1(1:4) /= wdcode(1:4)) then     ! next ward
         wdcode(1:4)=wdcode1(1:4)
         call wardconst(wdcode,wardT86)
      endif

!     Read in all SAS table data used as population estimate
!     constraints

      call readujm(U,Nm,nooft,fname,nooff,maxj,noofh) 

!     calculate Fjm
              
      call calcFjm(switch,maxj,Nm,nooft,U,F)
     
                                    
!*    Initialisation of E and k (indicator of replication no.)

        E=0
        k=0                                                                             

!     Initialisation of random number generator

!      iseed=getpid()
!      iseed=450

!*    -------- outputs are identified by edcode  
!      close(8)
!      close(9)
!      open(8,file='e:\Pop91t17\Rep\'//edcode//'.rep',status='replace') 
!      open(9,file='e:\Pop91t17\Res\'//edcode//'.res',status='replace')     

!      open(11,file=fname(11)(1:lnblnk(fname(11))),status='old')

!*      
  5     call cpu_time(time2)
        k=k+1
        write (5,*) edcode, k, ' run',(time2-time1)/60, 'cpu(m)'  
       
      call Random_Seed(PUT=iseed(k))
     
!     close any open output channels and open new ones, for new
!     ED/random no. combination

!*      close(8)                  
!*      close(9)

!*      call output() - hence remove sar2out.f95 and dffname.f95 from pop91a.prj
!      open(8,file=fname(8)(1:lnblnk(fname(8)))//edcode//'.rep')
!      open(9,file=fname(9)(1:lnblnk(fname(9)))//edcode//'.res')

!     Find first household combination to be tried from AreaSarComb

      call initcomb_a(Comb,noofh,fname,nooff,AreaSarSize,AreaSarComb)

!      call initcomb(Comb,noofh,fname,nooff,SarSize)

!     initialise Tjm,Rjm

            T=0; R=0

!     Aggregate households in comb to find SAS equivalent tables
!     (Tjm)

      call calctjm(switch,T,U,Nm,Comb,H13,H28,H,I,maxj,nooft, &                        !*
                   noofh,SarSize,noofi)
 
!     Find result of Ujm (SAS data) - Tjm (aggregated SAR data)

      call calcTAE(switch,T,U,maxj,nooft,Nm,TAE,STAE) 
!      write(8,*) 'Initial comb TAE = ',TAE      

!     Write out Ujm,Tjm,Rjm and TAE (includes an 'update' of Rjm)

      call report(switch,T,U,R,Nm,maxj,nooft,SarSize,minRjm,maxRjm,TAE)
 
!      call finalrep(maxj,Nm,nooft,T,U)

!      write(8,*) '        Old TAE   New TAE     Reduction'

!        write(13,*) edcode,'   k=',k        
!        write(14,*) edcode,'   k=',k 
                                              
      open(17,file=fname(17),status='old')          ! sa.limit
      
           call replace(edcode,wardT86,switch,T,U,R,Nm,maxj,nooft,SarSize,minRjm, &                   !*
              maxRjm,noofh,Comb,H,I,H28,H13,TAE,STAE,noofi,F,maxevals, &
              AreaSarSize,AreaSarComb,AreaCode)
!**   
           CombK(1:665,k)=Comb(1:665)      
                         
!      call report(switch,T,U,R,Nm,maxj,nooft,SarSize,minRjm,maxRjm,TAE)
      
      call calctjm(switch,T,U,Nm,Comb,H13,H28,H,I,maxj,nooft, &
                   noofh,SarSize,noofi) 
                   
!*    store T into E (the best of k runs)
        
        E(1:maxj,1:nooft,k)=T(1:maxj,1:nooft)  
                     
      if( k < maxseed) goto 5                           !     next random no

!      if (k==1) write(9,'(i7)') noofh 
!      write(9,'(i7)') noofh      
!      write(9,'(i7)') k
!      write(9,'(10i7)') (Comb(it),it=1,noofh)

!     Write out Ujm, Tjm and Z-scores in table format (only for the first run)

!      if (k .eq. 1) call finalrep(maxj,Nm,nooft,T,U)                            !*  


!*    OUTPUT A:
!*    household combination for each ED, each run   

      open(9,file='e:\Pop91t17\Res\'//edcode//'.res',status='replace')  
      write(9,'(i7)') noofh      
!      write(9,'(i7)') k
      do m=1,k
        write(9,*) m
        write(9,'(10i7)') (CombK(it,m),it=1,noofh)
      enddo
      close(9)

!*    OUTPUT B:
!*    actual and synthetic counts for each ED, each run
            
      open(10,file='e:\Pop91t17\Estimates\'//edcode//'.est',status='replace')
      
      ! store Ujm and Tjm for further analysis
                                                              !*                          
      write (10,*) edcode, noofh, maxevals, k
      write(10,*)

!     print U,E in the same format as SR for comparison      
            call newUT(switch,k,maxj,Nm,nooft,E,U)         
                            
!      do m=1,nooft
!       
!        if(switch(m)==0) goto 909         
!   
!        write(10,*) table(m), Nm(m)
!        write(10,'(199I4)') U(1:Nm(m),m)
!        do k=1,maxseed
!        write(10,'(199I4)') E(1:Nm(m),m,k)
!        enddo
!        write(10,*)  
! 909  continue    
!      enddo

        write(10,*)
        write(10,*)' NOTE: DATA ARE IN THE FOLLOWING ORDER'
        write(10,*)'       edcode, no. of households, no. of evaluations, no of replications'      
        write(10,*)'       table no., table cells'      
        write(10,*)'       SAS counts' 
        write(10,*)'       Estimates for each runs'

      close(10)
       
      goto 2
!     next ED
      
! 1919 continue
!      goto 3
!     next WD          

 1999   call cpu_time(time2)
        write (5,*) '   TOTAL CPU(hr) =',(time2-time1)/3600

                  
      stop
      end
