      subroutine replace(edcode,wardT86,switch,T,U,R,Nm,maxj,nooft,SarSize,minRjm, &
        maxRjm,noofh,Comb,H,I,H28,H13,TAE,STAE,noofi,F,maxevals,&
        AreaSarSize,AreaSarComb,AreaCode)

!     File name: replace_b.f95                              Date 8/7/2001

!     Using a simulated annealing heuristic, randomly choose a 
!     household in comb and test for replacement.  Potential 
!     replacement is randomly chosen from whole of Household SAR.
!     Replacement occurs if 'new' household brings about an
!     improvement in TAE, or if rand< e**(F-Best)/t), where e is a
!     constant, F is the fitness of the replacement (NewTAE) and Best
!     is the current household (TAE).  t is an counter which reduces
!     gradually during the run of the model.  T(emp) is reduced by 1
!     if more than 10*noofh successful hill climbs have been executed,
!     and in the current iteration no change has been made.

!----------------------------------------------------------------------------------

!       There are three measures of fitness to guide the section criteria

!       measure=1 : use overall TAE (TAE) only
!       measure=2 : use ocerall RSumZ2 (ORSumZ2) only
!       measure=3 : a combination of TAE and ORSumZ2
                                          
!*      17 Tables, based on sa3_b1.f95 but do not print out 
!*      select hoh with SEGHOH
!*      recalculate using the household seleted
!*      use ward (agg. ED) SEGHOH as a constrain for selection 
!*      (input data data/sas/wdcodeT86.dat, 
!       if wardT86=0 select another household)  
      
      implicit none
      integer T(0:maxj,1:nooft), U(0:maxj,1:nooft), R(0:maxj,1:nooft)
      integer Nm(1:nooft),maxRjm(1:nooft),BestComb(1:400)
      integer m,SarSize,maxj,nooft,minRjm(1:nooft)
      integer Comb(1:noofh), H(29:SarSize,1:nooft),I(1:noofi,1:nooft)
      integer H28(29:SarSize),H13(29:SarSize),BestNewTAE
      integer noofh,TAE,ind,noofi,minAE,maxhh,worsthh
      integer hh,hhno,minhh,AE,NewTAE,j
      integer STAE(nooft),SAE(nooft),NewSTAE(nooft),Fit,count2
      integer evaluations,rep,moves,limit,succ,BestTAE,eval,maxevals,&
                                          minevals, extraevals, moreevals
      real ran1, e, Temp, BestTemp, decr, Temp0, AcRSSZ                          !*
      double precision randm,rand2,rand3
      integer switch(nooft)                                                     !*
      integer CombBank(1:noofh), UseCombBank, NFT, NFC,PFC,Measure              !*
      integer ET(1:maxj,1:nooft,1), OTAE,tableTAE(1:nooft)                      !z
      real    ORSumZ2, RSumZ2(1:nooft),TRSumZ2,NewTRSumZ2                                          !z
      real    ORSumZ2a, ORSumZ2b, MaxRS,NewMaxRS                                !z1     
      real :: time,time1,t1,t2,t3
!*
      integer wardT86(1:76), noofrep
      character*6 edcode 
      real F(1:maxj,1:nooft)
      integer AreaSarSize,AreaSarComb(1:42000), AreaCode,AreaSarSwitch 
      real    AreaP            ! percentage of households in the area
                  
      OTAE=0; tableTAE=0; ORSumZ2=0.; RSumZ2=0.                      
      UseCombBank=0; NFT=20 ! just a non-zero                                                               !*
      time=0.; time1=0.
      
      Measure=2                ! 1,2,3 options
      AreaSarSwitch=1          ! 0-off, 1-on
                                                                                                              
      BestTAE=50000
      BestTemp=1000.0
      evaluations=0
      eval=0
      succ=0
      noofrep=0

      read(17,*) limit,temp0,decr
      read(17,*) minevals, extraevals, moreevals
      read(17,*) AcRSSZ
      
      close(17)
      temp=temp0
      maxevals=minevals
      
!*      write(8,*) evaluations, TAE, limit, temp, decr

!     Initialise unused part of BestComb

      do 2,hh=noofh+1,400
         BestComb(hh)=0
 2    continue 
 
                                                        call cpu_time(t1)
 3    moves=0

!     1.  Randomly select a household for replacement

         call Random_Number(randm)
         hh=int(randm*noofh)+1

         hhno=Comb(hh)
         AE=TAE
         SAE=STAE
                              
!     (Re) set Rjm for current Ujm-Tjm

         do 5,m=1,nooft; if(switch(m)==0) goto 5   
            R(0,m)=0
            do 7,j=1,Nm(m)
               R(j,m)=U(j,m)-T(j,m)
               R(0,m)=R(0,m)+R(j,m)
 7          continue
 5       continue   

      if(Measure /= 1 .and. evaluations == 0) then
         
         do 50, m=1,nooft;  if(switch(m)==0) goto 50   
            RSumZ2(m)=0.
            do j=1,Nm(m)
               RSumZ2(m)=RSumZ2(m)+F(j,m)*R(j,m)**2
            enddo
 50      continue
         TRSumZ2=sum(RSumZ2(1:nooft))

!         MaxRS=max(RSumZ2(1:nooft))

      endif 

!         NewTRSumZ2=TRSumZ2 
   
!     If Ujm-Tjm>=0 then add 1 to TAE, else subtract 1 from TAE
!     N.B.  Does not apply when j=0 (ie hh/ind n/a for table)
!     For the moment, n/a values of j are assumed to be 'neutral'
!     in affect on TAE.

      evaluations=evaluations+1

      do 52, m=1,nooft;    if(switch(m)==0) goto 52          

         goto (54,58,54,58,54,58,54,58,54,54,54,58,54,54,58,58,54),m            !*

 54         do 56,ind=h28(hhno),(h28(hhno)+(H13(hhno)-1))
               if (I(ind,m) .gt. 0) then
                 
!                        ET(I(ind,m),m,1)=ET(I(ind,m),m,1)-1                     !z1 
!z                     
!                     if(measure /=1) &
!                     NewTRSumZ2=NewTRSumZ2+F(j,m)* &
!                        ((R(I(ind,m),m)+1)**2-R(I(ind,m),m)**2) 
                                                                                                    
                  if (R(I(ind,m),m) .ge. 0) then

                     !  SAE(m)=SAE(m)+1
                     AE=AE+1
                     R(I(ind,m),m)=R(I(ind,m),m)+1

                  else
                     !  SAE(m)=SAE(m)-1
                     AE=AE-1
                     R(I(ind,m),m)=R(I(ind,m),m)+1 

                  endif
               endif
 56         continue

            goto 52

 58         if (H(hhno,m) .gt. 0) then  
 
!                        ET(H(hhno,m),m,1)=ET(H(hhno,m),m,1)-1                   !z1
!z                     
!                     if(measure /=1) &
!                     NewTRSumZ2=NewTRSumZ2+F(j,m)* &
!                        ((R(H(hhno,m),m)+1)**2-R(H(hhno,m),m)**2)                  
                                     
               if (R(H(hhno,m),m) .ge. 0) then
                  !  SAE(m)=SAE(m)+1
                  AE=AE+1
                  R(H(hhno,m),m)=R(H(hhno,m),m)+1
     
               else
                  !  SAE(m)=SAE(m)-1
                  AE=AE-1
                  R(H(hhno,m),m)=R(H(hhno,m),m)+1

               endif
            endif
 52      continue
!     next m

!  write (5,*) '  evaluations=', evaluations

            minAE=AE
            minhh=hh
            worsthh=Comb(minhh)

!     Remove selected household from Tjm

      call removeh(switch,T,maxj,nooft,H,SarSize,I,noofi,h28,h13,worsthh,Nm)

  
!     2.  Scroll through all households, evaluating number of times
!         household or household individuals are 'required' by Rjm
!         Evaluate also NewTAE and print out minTAE-NewTAE

      NewTAE=minAE
      ! NewSTAE=SAE


 60   call Random_Number(randm)
 
 !***   
      if (UseCombBank .eq. 0) then             ! select randomly from SAR

        if (AreaSarSwitch ==1) then       
                maxhh=AreaSarComb(int(randm*AreaSarSize)+1)      ! from area SAR
        else
                maxhh=int(randm*(SarSize-28))+29       ! select randomly from SAR  
        endif
         
!        maxhh=int(randm*(SarSize-28))+29

!       Pick another household if no tenure (i.e. if Scottish LA etc.)
        if (H(maxhh,2).eq.0) go to 60

!*      Pick another household if no SEGHOH
        if (H(maxhh,8).eq.0) go to 60 

!*      Pick another household if SEGHOH not match the constrain of wardT86
!       (if the selected J value of table 86 is in the zero cell of wardT86) 

        if (wardT86(H(maxhh,8)).eq.0) go to 60   
                  
      else                                     ! only select those in CombBank
      
        maxhh=CombBank(int(randm*noofh)+1)
        
      endif
!***  

        
!     Having tested household, 'refresh' Rjm for current Tjm
!     Could place at end of loop, but position here allows
!     call of report.f above to be commented out

         do 8,m=1,nooft;  if(switch(m)==0) goto 8   
            R(0,m)=0
            do 9,j=1,Nm(m)
               R(j,m)=U(j,m)-T(j,m)                          ! R after take one out
               R(0,m)=R(0,m)+R(j,m)
 9          continue
 8       continue

!     Find what TAE would be if 'best' household is added

      evaluations=evaluations+1

      do 160,m=1,nooft
!*
        if(switch(m)==0) goto 160
          
        goto (170,190,170,190,170,190,170,190,170,170,170,190,170,170,190,190,170), m !*

!     If Ujm-Tjm>0 subtract 1 from TAE, else add 1

 170        do 180,ind=h28(maxhh),(h28(maxhh)+(H13(maxhh)-1))
               if (I(ind,m) .gt. 0) then
                 
!                        ET(I(ind,m),m,1)=ET(I(ind,m),m,1)+1                     !z1 
!z                     
!                     if(measure /=1) &
!                     NewTRSumZ2=NewTRSumZ2+F(j,m)* &
!                        ((R(I(ind,m),m)-1)**2-R(I(ind,m),m)**2)                     
                                                                          
                  if (R(I(ind,m),m) .gt. 0) then
                     !  NewSTAE(m)=NewSTAE(m)-1
                     NewTAE=NewTAE-1
                     R(I(ind,m),m)=R(I(ind,m),m)-1

                  else
                     !  NewSTAE(m)=NewSTAE(m)+1
                     NewTAE=NewTAE+1
                     R(I(ind,m),m)=R(I(ind,m),m)-1

                  endif
               endif
 180        continue

            goto 160

 190        if (H(maxhh,m) .gt. 0) then
  
!                        ET(H(maxhh,m),m,1)=ET(H(maxhh,m),m,1)+1                   !z1
!z                     
!                     if(measure /=1) &
!                     NewTRSumZ2=NewTRSumZ2+F(j,m)* &
!                        ((R(H(maxhh,m),m)-1)**2-R(H(maxhh,m),m)**2)
                             
               if (R(H(maxhh,m),m) .gt. 0) then
                  !  NewSTAE(m)=NewSTAE(m)-1
                  NewTAE=NewTAE-1
                  R(H(maxhh,m),m)=R(H(maxhh,m),m)-1                 
                  
               else
                  !  NewSTAE(m)=NewSTAE(m)+1
                  NewTAE=NewTAE+1
                  R(H(maxhh,m),m)=R(H(maxhh,m),m)-1                      
                  
               endif               
            endif
 160     continue                                            ! R after add one
!     next m

      if(Measure /= 1) then
         
         do 55, m=1,nooft;  if(switch(m)==0) goto 55   
            RSumZ2(m)=0.
            do j=1,Nm(m)
               RSumZ2(m)=RSumZ2(m)+F(j,m)*R(j,m)**2
            enddo
 55      continue
 
!         ORSumZ2=sum(RSumZ2(1:nooft))
         NewTRSumZ2=sum(RSumZ2(1:nooft))
!         NewMaxRS=max(RSumZ2(1:nooft))

      endif 


!     if fitness (NewTAE) of replacement household is better (or equal)
!     than fitness (TAE) of old household, then replace.
!     if NewTAE>TAE replace if rand<e**((NewTAE-TAE)/Temp)

      rep=0 

      
      if (Measure == 1) then 
! (1)       
         if (TAE .ge. NewTAE) then
            rep=1
         else
              call Random_Number(randm) 
              if (Temp .lt. 0.0001) temp=0.0001      ! avoid temp=0
              if (randm .lt. (exp(real(TAE-NewTAE)/Temp))) rep=1
         endif       

      elseif (Measure == 2) then      
! (2)  
!        if (ORSumZ2a > ORSumZ2b) then   
        if (TRSumZ2 > NewTRSumZ2) then
                rep=1
         else 
!        elseif ( MaxRS > NewMaxRS) then
              call Random_Number(randm) 
              if (Temp .lt. 0.00001) temp=0.00001      ! avoid temp=0
              if (randm .lt. (exp(real(TRSumZ2-NewTRSumZ2)*100./Temp))) rep=1                      
        endif
! (3)                  
      elseif (Measure == 3) then                     ! no good
      
         if (TAE > NewTAE .and. TRSumZ2 > NewTRSumZ2) then             
                rep=1
                TRSumZ2=NewTRSumZ2                    
                TAE=NewTAE
         endif                                                                                                                    
      else

      endif                                                      
         
!      goto  999         
! z1======================================================================= 

              
  999 continue    

!     if a replacement h/hold is selected, then set moves flag to 1
!     and add 1 to couter of 'successes' for current temp cycle.
         if (rep .eq. 1) then  
            TRSumZ2=NewTRSumZ2
            noofrep=noofrep+1                                                    !z
            succ=succ+1
            moves=1
         endif

!     if no replacement household has been selected, make
!     'replacement' household = original household and re-set NewTAE
!     to original TAE

         if (rep .eq. 0) then
            maxhh=worsthh
            NewTAE=TAE
            ! NewSTAE=STAE 
         endif

!     Having found 'best' household (maxhh), need to add to Tjm

      call addh(switch,T,maxj,nooft,H,SarSize,I,noofi,h28,h13,maxhh,Nm)



!     Update TAE after removal of worst and addition of best h/hold.

      TAE=NewTAE
      STAE=NewSTAE

!     replace 'worst' household in combination with 'better' hhold

      Comb(minhh)=maxhh

!     Update record of best solution found to date, if appropriate

      if (Measure == 1) then 

        if (TAE .lt. BestTAE) then
         BestTAE=TAE
         BestTemp=temp
         do 294,hh=1,noofh
            BestComb(hh)=Comb(hh)
 294     continue
        endif 
      endif  
   
!            write(5,*) evaluations,TAE,TRSumZ2,NewTRSumZ2,ORSumZ2       !* 
!            write(13,*) evaluations,noofrep,TAE,TRSumZ2,rep            !* 
                          
!      if (evaluations .lt. 25000) then
!         if (evaluations .gt. eval) then 
!            write(5,*) evaluations,noofrep,TAE,TRSumZ2,rep            !*     
!            eval=eval+5000
!         endif
!         if (mod(evaluations,25000) .eq. 0) &                     !*
!            write(5,*) evaluations,noofrep,TAE,TRSumZ2,rep            !*  
            
!      endif
!===============================================================
      if ((succ .gt. limit) .and. (moves .eq. 0)) then
!         Temp=Temp*0.95
         Temp=Temp*decr
!         if (temp .lt. 0.01) temp=0.1
!         if (temp .lt. 0.001) temp=0.01
         succ=0
!         write(8,*) evaluations,TAE,NewTAE,TAE-NewTAE,temp
!         write(8,*) evaluations,newtae,BestTAE,temp
      endif 

!      if ((temp .gt. 0.2) .and. (TAE .gt. 0)) goto 3
!      if ((evaluations .lt. maxevals) .and. (TAE .gt. 0)) goto 3
!      if ((evaluations .lt. 10000000) .and. (TAE .gt. 0)) goto 3

!8 -----------------------------------------------------------------------  
!       after a xxx evaluations if NFC not eq zero, select from whole SAR 

      if (evaluations == 200000) then
        call calctjm(switch,T,U,Nm,Comb,H13,H28,H,I,maxj,nooft, &
                   noofh,SarSize,noofi)
         
           ET(1:maxj,1:nooft,1)=T(1:maxj,1:nooft)                                                            
        call analysis0z(edcode,switch,1,maxj,Nm,nooft,ET,U,NFT,NFC,PFC,&
                        OTAE,ORSumZ2,TableTAE,RSumZ2)
                        
        if (NFC /= 0 ) AreaSarSwitch=0      ! off area SAR  
      endif  
!8 -----------------------------------------------------------------------               
      
       if (evaluations .lt. maxevals) goto 3


      if (Measure == 1) then 
        do 300,hh=1,noofh
         Comb(hh)=BestComb(hh)         
 300    continue  
      endif
      
!      write(5,*) 'maxevals, BestTAE and Index',maxevals, BestTAE, Index  

!***  after reaching maxevals check if extra evaluations needed 
!     Measures  
!       NFT: no of not fit tables (SumofZsq>c.v)
!       NFC: no of not fit cells  (Z>1.96)
!       PFC: no of pool fit cells  (Z&Z+1&Z-1>1.96) 
                                                        call cpu_time(t2)
                                                                                                                                                     
      call calctjm(switch,T,U,Nm,Comb,H13,H28,H,I,maxj,nooft, &
                   noofh,SarSize,noofi)
         
           ET(1:maxj,1:nooft,1)=T(1:maxj,1:nooft)                                                            
      call analysis0z(edcode,switch,1,maxj,Nm,nooft,ET,U,NFT,NFC,PFC,&
                        OTAE,ORSumZ2,TableTAE,RSumZ2)
                         
      call calcAreaP(noofh,Comb,AreaCode,AreaP) 
      
                                                        call cpu_time(t3)                     
                                                        time1=time1+t3-t2
                                                      !  time=t3-t1-time1 
                                                        time=t3-t1
!**** 
!      write(5,*) ' ',maxevals,NFT,NFC,PFC,OTAE,ORSumZ2      
!      write(5,*) ' ',maxevals,NFT,NFC,PFC,OTAE,BestTAE,ORSumZ2 
!8   
!8       write(13,'(a21,f6.1,i9,i6,3i4,i6,f8.2,17i5,17f6.2,f9.6,f7.1)')' eval/1&2&3/OTAE/ORS/',&
!8        time,maxevals,noofrep,NFT,NFC,PFC,OTAE,ORSumZ2,tableTAE(1:17),RSumZ2(1:17),temp,AreaP               

!        if ((NFT == 0) .and. (NFC < AcRSSZ) ) then
   
        if ((NFC == 0) .and. (ORSumZ2 < AcRSSZ) ) then
                goto 3333                     
        else
             AreaSarSwitch=0  
        endif  
        
        if ((maxevals == 3000000) .and. (NFC == 0)) goto 3333 
                          
!        if (maxevals==minevals) then  
!                if ((NFC == 0) .and. (ORSumZ2 < 0.5) ) then
!                        goto 3333                                             
!                else
!                        AreaSarSwitch=0
!                        maxevals=int((ORSumZ2-0.5)*3*minevals)                                                   
!                        goto 3
!                endif        
!        endif 
!        goto 3333
!****        
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
        if (maxevals < minevals+extraevals) then            
                maxevals=maxevals+500000         ! check every 0.5m runs
!8               if (maxevals < 10000) then
!8                       maxevals=maxevals+10000 
!8               elseif (maxevals < 100000) then  
!8                       maxevals=maxevals+90000 
!8               elseif (maxevals < 500000) then  
!8                       maxevals=maxevals+400000                        
!8               elseif (maxevals < 4000000) then  
!8                       maxevals=maxevals+500000 
!8               else   
!8                       maxevals=maxevals+1000000                       
!8               endif
                                                 
                goto 3
                
        elseif (NFC /= 0) then  
!        elseif (NFT /= 0) then  
!8         else
                if (UseCombBank == 1) goto 3333 
        !***    Recalculate but only selecte those househouls in CombBank=BestComb                                                                                         
                UseCombBank=1
                CombBank=Comb
                maxevals=maxevals+moreevals        !  more evaluations
                Temp=Temp0*0.5
                Succ=0
                goto 3
!        else                                 
        endif        
        
 3333   continue  
 
      write(5,*) ' ',maxevals,NFT,NFC,OTAE,ORSumZ2,AreaP 
       write(13,'(a6,2x,f6.1,i9,i6,3i4,i6,f8.2,17i5,17f6.2,f9.6,f7.1,i6)') edcode,  &
       time,maxevals,noofrep,NFT,NFC,PFC,OTAE,ORSumZ2,tableTAE(1:17),RSumZ2(1:17),temp,AreaP,noofh 
                         
      return
      end
